力扣496. 下一个更大元素 I

由于nums1数组是nums2数组的子集,所以可以直接在nums2s数组把每个数的下一个更大数用map来标记
寻找一个数的下一个更大数可以用单调栈,从数组的末尾反向遍历,维护一个单调递减的栈,(也可以从左往右遍历,维护一个单调递增的栈,从栈顶到底部单调递增)

class Solution {
public:
    vector<int> nextGreaterElement(vector<int>& nums1, vector<int>& nums2) {
            unordered_map<int,int> m;
            stack<int> st;
            for(int i = nums2.size()-1; i >=0; i--){
                int num = nums2[i];
                while(!st.empty()&&num >= st.top()){
                    st.pop();
                }
                if(st.empty())
                m[num] = -1;
                else m[num] = st.top();
                st.push(num);
            }
            vector<int> ans(nums1.size());
            for(int i = 0; i < nums1.size(); i++){
                ans[i] = m[nums1[i]];
            }
            return ans;
    }
};```
posted @ 2024-07-22 16:51  binbin成长日记  阅读(43)  评论(0)    收藏  举报